<?php

class controllers_postal extends library_controller{

	public function indexAction(){
	
		$model = new models_usuario();
		
		$this->usuario = $model->getLoggedUsusario();
		
		if(!$this->usuario):
		
			$this->addMessage('Por favor regístrate o ingresa con tu número de documento');
			
			$this->redirect('');
				
			return;
		
		endif;
		
		$this->postal = $model->getPostal();
		
		if($this->postal->estado == 1):
			
			$this->redirect('postal/ver');
			
			return;
			
		endif;
		
		$this->render('crear_postal');

	}
	
	public function verAction(){

		$model = new models_usuario();
		
		$this->usuario = $model->getLoggedUsusario();
		
		if(!$this->usuario):
		
			$this->addMessage('Por favor regístrate o ingresa con tu número de documento');
			
			$this->redirect('');
				
			return;
		
		endif;
		
		$this->postal = $model->getPostal();
		
		if($this->postal->estado == 2):
			
			$this->addMessage('Por favor termina de agregar las fotos de tus amigos a la postal');
			
			$this->redirect('postal');
			
			return;
			
		endif;
		
		$this->render('ver_postal');
	
	}
		
	public function publicaAction(){
	
		$documento = $this->getParam('id');
		
		$model = new models_usuario();
		
		$this->usuario = $model->getUsuario($documento);
		
		$this->postal = $model->getPostal($documento);
		
		if($this->postal->estado == 2):
			
			$this->redirect('');
			
			return;
			
		endif;
		
		$this->render('publica_postal');
	
	}
	
	// ajax actions
	
	public function compartirfacebookAction(){
	
		$model = new models_usuario();
		
		$this->usuario = $model->getLoggedUsusario();
		
		if(!$this->usuario):
		
			$response = array("status" => "error", "value" => "Por favor regístrate o ingresa con tu número de documento");
		
			echo json_encode($response);
				
			return;
		
		endif;
	
		$requests = $this->getPost('request_ids');
		
		if($requests):
		
			$requests_ids = explode(',',$requests);
			
			if(count($requests_ids) == 0):
		
				$response = array("status" => "error", "value" => "Por favor selecciona tus amigos");
		
				echo json_encode($response);
				
				return;
		
			endif;
			
			$model = new models_usuario();
			
			$usuario = $model->getLoggedUsusario();
			
			$documento = $usuario->numero_documento;
					
			foreach($requests_ids as $request_id):
			
				$model->guardarInvitacion($request_id, 'facebook_request', $documento);
			
			endforeach;
			
			$response = array("status" => "success");

			echo json_encode($response);
			
			return;
		
		endif;
		
		$response = array("status" => "error", "value" => "Por favor selecciona tus amigos");
		
		echo json_encode($response);
		
		return;
	
	}
	
	
	public function compartirtfacebookfeedAction(){
	
		$model = new models_usuario();
		
		$this->usuario = $model->getLoggedUsusario();
		
		if(!$this->usuario):
		
			$response = array("status" => "error", "value" => "Por favor regístrate o ingresa con tu número de documento");
		
			echo json_encode($response);
				
			return;
		
		endif;
	
		$model = new models_usuario();

		$usuario = $model->getLoggedUsusario();
		
		$documento = $usuario->numero_documento;

		$model->guardarInvitacion('', 'facebook_feed', $documento);

	}
	
	public function compartirtwitterAction(){
	
		$model = new models_usuario();
		
		$this->usuario = $model->getLoggedUsusario();
		
		if(!$this->usuario):
		
			$response = array("status" => "error", "value" => "Por favor regístrate o ingresa con tu número de documento");
		
			echo json_encode($response);
				
			return;
		
		endif;
	
		$model = new models_usuario();

		$usuario = $model->getLoggedUsusario();
		
		$documento = $usuario->numero_documento;

		$model->guardarInvitacion('', 'twitter', $documento);

	}
	
	public function compartiremailAction(){
	
		$model = new models_usuario();
		
		$this->usuario = $model->getLoggedUsusario();
		
		if(!$this->usuario):
		
			$this->addMessage('Por favor regístrate o ingresa con tu número de documento');
			
			$this->redirect('');
				
			return;
		
		endif;	

		$data = $this->getPost('form');
				
		if($data):
			
			try{
			
				$emails = explode(" ", $data['emails']);
			
				$model = new models_usuario();
			
				$usuario = $model->getLoggedUsusario();

				$documento = $usuario->numero_documento;
				
				$body = '<h2>Recuerdo de la celebración!!!</h2>';
				
				$body .= '<p>LAN cumple 10 años transportando sueños Ecuatorianos por el mundo, y he creado una postal de celebración de su aniversario.</p>';

				$body .= '<p>Puedes verla ingresando <a href="'.$this->getUrl($documento).'">aquí</a></p>';
				
				$mailer = new library_phpmailer();
				
				$mailer->SetFrom('no-reply@lan.com', 'LAN');

				foreach($emails as $email):
					
					$mailer->AddAddress($email, $email);
					
					$model->guardarInvitacion($email, 'email', $documento);
					
				endforeach;
				
				$mailer->Subject = utf8_decode("Recuerdo de la celebración!!!");
				
				$mailer->MsgHTML($body);
				
				$mailer->Send();
				
				$this->redirect('postal/ver');
		
				return;
				
			}catch(Exception $e){
			
				$this->addMessage($e->getMessage());
				
				$this->redirect('postal/ver');
				
				return;

			}

		endif;

		$this->addMessage('Por agrega el correo de tus amigos separados por comas');
		
		$this->redirect('postal/ver');
		
		return;
	
	}
		
	public function guardarpostalAction(){
	
		$model = new models_usuario();
		
		$this->usuario = $model->getLoggedUsusario();
		
		if(!$this->usuario):
		
			$response = array('type' => 'error', 'message' => 'Por favor regístrate o ingresa con tu número de documento');
			
			echo json_encode($response);
			
			return;
		
		endif;
	
		$data = $this->getPost('form');
		
		if($data):
			
			try{
			
				$model = new models_usuario();
			
				$usuario = $model->getLoggedUsusario();

				$documento = $usuario->numero_documento;

				$model->guardarPostal($documento);
				
				$response = array('type' => 'success');
				
				echo json_encode($response);
				
				return;
				
			}catch(Exception $e){
			
				$response = array('type' => 'error', 'message' => $e->getMessage());
				
				echo json_encode($response);
				
				return;
			
			}

		endif;
		
		$response = array('type' => 'error', 'message' => 'Por favor llena todos los campos');
		
		echo json_encode($response);

		return;
	
	}
	
	public function dedoAction(){
		
		$dedo = $this->getPost('dedo');

		if($dedo):
		
			if($dedo['tipo'] == 'facebook'):
			
				$this->dedoFacebook($dedo);
			
			elseif($dedo['tipo'] == 'uploader'):
			
				$this->dedoUploader($dedo);
			
			endif;
		
			$this->redirect('postal');
			
			return;
		
		endif;
		
		$this->addMessage('Error al guardar la imagen');
		
		$this->redirect('postal');
		
		return;
	
	}
	
	public function dedoUploader($dedo){

		$model = new models_usuario();
		
		$usuario = $model->getLoggedUsusario();
		
		$documento = $usuario->numero_documento;
		
		$extension = strtolower(strrchr($dedo['imagen'], '.'));
		
		// imagen
		
		$imagen_facebook = APP_PATH.DS.'tmp'.DS.'tmp_'.$documento.'_'.$dedo['activo'].$extension;
		
		// resize imagen
		
		$model_resize = new library_resize($imagen_facebook, $dedo);
		
		$resize_width = str_replace("px","",$dedo['imagen_w']);

		$resize_imagen = $model_resize->resize($resize_width);
		
		
		// crop imagen
		
		$imagen = imagecreatefromjpeg($resize_imagen);

		$dedo_imagen = ImageCreateTrueColor($dedo['w'], $dedo['h']);
		
		imagecopyresampled($dedo_imagen, $imagen, 0, 0, $dedo['x'], $dedo['y'], $dedo['w'], $dedo['h'], $dedo['w'], $dedo['h']);
		
		$key = time();
		
		$dedo_nombre = $key.'_'.$documento.'_'.$dedo['activo'].$extension;
		
		$dedo_path = APP_PATH.DS.'media'.DS.$dedo_nombre;
		
		imagejpeg($dedo_imagen, $dedo_path, 100);
		
		unlink(APP_PATH.DS.'tmp'.DS.'tmp_'.$documento.'_'.$dedo['activo'].$extension);
		
		unlink(APP_PATH.DS.'tmp'.DS.'tmp_'.$documento.'_'.$dedo['activo'].'_resize'.$extension);
			
		$model->actualizarDedo($dedo_nombre, $dedo['activo'], $documento);
		
		return true;
		
	
	}
	
	public function dedoFacebook($dedo){
	
		$model = new models_usuario();
		
		$usuario = $model->getLoggedUsusario();
		
		$documento = $usuario->numero_documento;
		
		$extension = strtolower(strrchr($dedo['imagen'], '.'));
		
		// descargar imagen de facebook
		
		$imagen_facebook = APP_PATH.DS.'tmp'.DS.'tmp_'.$documento.'_'.$dedo['activo'].$extension;

		file_put_contents($imagen_facebook, file_get_contents($dedo['imagen']));
		
		// resize imagen facebook
		
		$model_resize = new library_resize($imagen_facebook, $dedo);
		
		$resize_width = str_replace("px","",$dedo['imagen_w']);

		$resize_imagen = $model_resize->resize($resize_width);
		
		// crop imagen
		
		$imagen = imagecreatefromjpeg($resize_imagen);

		$dedo_imagen = ImageCreateTrueColor($dedo['w'], $dedo['h']);
		
		imagecopyresampled($dedo_imagen, $imagen, 0, 0, $dedo['x'], $dedo['y'], $dedo['w'], $dedo['h'], $dedo['w'], $dedo['h']);
		
		$key = time();
		
		$dedo_nombre = $key.'_'.$documento.'_'.$dedo['activo'].$extension;
		
		$dedo_path = APP_PATH.DS.'media'.DS.$dedo_nombre;
		
		imagejpeg($dedo_imagen, $dedo_path, 100);
		
		unlink(APP_PATH.DS.'tmp'.DS.'tmp_'.$documento.'_'.$dedo['activo'].$extension);
		
		unlink(APP_PATH.DS.'tmp'.DS.'tmp_'.$documento.'_'.$dedo['activo'].'_resize'.$extension);
		
		$model->actualizarDedo($dedo_nombre, $dedo['activo'], $documento);
		
		return true;
		
	}
	
	public function uploaderAction(){
		
		$uploader = new library_uploader('qqfile');
		
		$response = $uploader->upload();
	
		header("Content-Type: text/plain");
		
		echo json_encode($response);

	}
	
	// vista
	
	public function getExcludeIds(){
	
		$model = new models_usuario();
		
		$excludes = $model->getExcludeIds();
	
		return $excludes;
		
	}
	
	public function getDedo($dedo,$value = false){
		
		if($dedo == 1):
			
			if($this->postal->dedo_1 != ""):
			
				$imagen = '<img src="'.$this->getUrl('media/'.$this->postal->dedo_1).'" />';
				
				if($value):
					
					return $this->postal->dedo_1;
					
				else:
				
					return $imagen;
				
				endif;
				
			endif;
		
		elseif($dedo == 2):
		
			if($this->postal->dedo_2 != ""):
			
				$imagen = '<img src="'.$this->getUrl('media/'.$this->postal->dedo_2).'" />';
				
				if($value):
					
					return $this->postal->dedo_2;
					
				else:
				
					return $imagen;
				
				endif;
				
			endif;
		
		elseif($dedo == 3):
		
			if($this->postal->dedo_3 != ""):
			
				$imagen = '<img src="'.$this->getUrl('media/'.$this->postal->dedo_3).'" />';
				
				if($value):
					
					return $this->postal->dedo_3;
					
				else:
				
					return $imagen;
				
				endif;
				
			endif;
		
		elseif($dedo == 4):
		
			if($this->postal->dedo_4 != ""):
			
				$imagen = '<img src="'.$this->getUrl('media/'.$this->postal->dedo_4).'" />';
				
				if($value):
					
					return $this->postal->dedo_4;
					
				else:
				
					return $imagen;
				
				endif;
				
			endif;
		
		endif;
		
		return;
	
	}
	
	public function getDocumento(){
		
		$model = new models_usuario();
		
		$this->usuario = $model->getLoggedUsusario();
		
		$documento = $this->usuario->numero_documento;
		
		return $documento;
		
	}
	
	public function getRankingUsuario($id){
	
		$model = new models_usuario();
		
		$usuarios = $model->getRanking();
		
		$rank = 1;

		foreach($usuarios as $usuario):
		
			if ($usuario->id_usuario == $id):
			
				return $rank;
			
			endif;
		
			++$rank;
	
		endforeach;
		
		return 1;
	
	}
	
	public function rankingAction(){
		
		$page = $this->getParam('page');
		
		if($page):
		
			$model = new models_usuario();
			
			$this->usuarios = $model->getRanking($page);
			
			$this->getPart('ranking_list');
			
			return;
		
		endif;
		
		return;
	
	}
	
	public function rankingbuscarAction(){
		
		$value = $this->getPost('value');
	
		if($value):
		
			$model = new models_usuario();
			
			$this->usuarios = $model->getBuscarRanking($value);
			
			$this->getPart('ranking_list');
			
			return;
		
		endif;
	
	}
	
}