(function () {
    var onload = window.onload;

    window.onload = function () {
        if (typeof onload == "function") {
            onload.apply(this, arguments);
        }

        var fields = [];
        var inputs = document.getElementsByTagName("input");
        var textareas = document.getElementsByTagName("textarea");

        for (var i = 0; i < inputs.length; i++) {
            fields.push(inputs[i]);
        }

        for (var i = 0; i < textareas.length; i++) {
            fields.push(textareas[i]);
        }

        for (var i = 0; i < fields.length; i++) {
            var field = fields[i];

            if (typeof field.onpaste != "function" && !!field.getAttribute("onpaste")) {
                field.onpaste = eval("(function () { " + field.getAttribute("onpaste") + " })");
            }

            if (typeof field.onpaste == "function") {
                var oninput = field.oninput;

                field.oninput = function () {
                    if (typeof oninput == "function") {
                        oninput.apply(this, arguments);
                    }

                    if (typeof this.previousValue == "undefined") {
                        this.previousValue = this.value;
                    }

                    var pasted = (Math.abs(this.previousValue.length - this.value.length) > 1 && this.value != "");

                    if (pasted && !this.onpaste.apply(this, arguments)) {
                        this.value = this.previousValue;
                    }

                    this.previousValue = this.value;
                };

                if (field.addEventListener) {
                    field.addEventListener("input", field.oninput, false);
                } else if (field.attachEvent) {
                    field.attachEvent("oninput", field.oninput);
                }
            }
        }
    }
})();


function redirect(url){
    window.location.href = url;
}
jQuery.noConflict();
jQuery(function(){
	jQuery.validator.addMethod("validate-emails", function(value, element) {
		if(value != jQuery("#form_correo").val()){
			return false;
		}
		return true;
	}, "Por favor, confirme su correo");
	
	jQuery.validator.addMethod("validate-documento", function(value, element) {
		if(value.length == 10){
			return true;
		}
		return false;
	}, "Ingrese un documento valido");
	
	jQuery.validator.addMethod("validate-emails", function(value, element) {
		emails = value.split(',');
		response = false;
		validos = 0;
		jQuery.each(emails, function(index, value) {
			var emailRegEx = /^(([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+)(([\s]*[;,]+[\s]*(([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+))*)$/;
			if(emailRegEx.test(value)){
				validos = validos + 1;
			}
		});
		if(validos == emails.length){
			return true;
		}
		return false;
	}, "Por favor verifica los correos electronicos");
	
	jQuery(".dialog-mecanica").fancybox({
		'padding' : 0,
		'autoSize' : false,
		'autoHeight' : false,
		'autoWidth' : false,
		'width' : 630,
		'height' : 443,
		'aspectRatio' : false,
		'autoResize' : false,
		'scrolling' : 'no'
	});
	
	jQuery(".dialog-login").fancybox({
		'padding' : 0,
		'autoSize' : false,
		'autoHeight' : false,
		'autoWidth' : false,
		'width' : 630,
		'height' : 215,
		'aspectRatio' : false,
		'autoResize' : false,
		'scrolling' : 'no',
		afterShow: function(){
			jQuery('.login_tipo_doc').click(function() {
				if (jQuery(this).val() == '1'){
					jQuery('.login_numero_documento').addClass('validate-documento');
					jQuery('.login_numero_documento').addClass('number');
				}else{
					jQuery('.login_numero_documento').removeClass('validate-documento');
					jQuery('.login_numero_documento').removeClass('number');
				}
			});
			jQuery("#loginForm").validate({
				errorPlacement: function(error, element) {
					jQuery(element).prev().css('color', '#CC0000');
				},
				unhighlight: function( element, errorClass, validClass ) {
					jQuery(element).prev().css('color', '#444444');	
					jQuery(element).removeClass(errorClass).addClass(validClass);
				}
			});
		}
	});
	
	jQuery(".dialog-registro").fancybox({
		'padding' : 0,
		'autoSize' : false,
		'autoHeight' : false,
		'autoWidth' : false,
		'width' : 630,
		'height' : 443,
		'aspectRatio' : false,
		'autoResize' : false,
		'scrolling' : 'no',
		afterShow: function(){
			jQuery('.registro_tipo_doc').click(function() {
				if (jQuery(this).val() == '1'){
					jQuery('.registro_numero_documento').addClass('validate-documento');
					jQuery('.registro_numero_documento').addClass('number');
				}else{
					jQuery('.registro_numero_documento').removeClass('validate-documento');
					jQuery('.registro_numero_documento').removeClass('number');
				}
			});
			jQuery("#registroForm").validate({
				errorPlacement: function(error, element) {
					jQuery(element).prev().css('color', '#CC0000');
				},
				unhighlight: function( element, errorClass, validClass ) {
					jQuery(element).prev().css('color', '#444444');	
					jQuery(element).removeClass(errorClass).addClass(validClass);
				}
			});
		}
	});
	
});